<template>
  <v-dialog
    :value="value"
    @click:outside="closeRequest"
    @keydown.esc="closeRequest"
    max-width="800"
  >
    <v-stepper v-model="stepperValue">
      <v-stepper-header class="shadow-none">
        <v-stepper-step step="1" :complete="stepperValue > 1"
          >Choix du savoir</v-stepper-step
        >
        <v-stepper-step step="2" :complete="stepperValue > 2"
          >Choix de la date de l'évalution
        </v-stepper-step>
        <v-stepper-step step="3" :complete="stepperValue > 3"
          >Evaluation
        </v-stepper-step>
      </v-stepper-header>
      <v-stepper-items>
        <div class="italic text-sm p-7" v-if="matieres.length === 0">
          Pas de matières ajoutées
        </div>
        <v-stepper-content step="1">
          <v-expansion-panels flat>
            <v-expansion-panel
              v-for="matiere in matieres"
              :key="matiere.id"
              @click="selectMatiere(matiere)"
            >
              <v-expansion-panel-header>
                <div class="font-semibold text-xl">
                  {{ matiere.nom }}
                </div>
              </v-expansion-panel-header>
              <v-expansion-panel-content>
                <div v-if="savoirs.length === 0">
                  <div class="italic text-sm">
                    Pas de savoirs correspondants dans le bulletin
                  </div>
                </div>
                <div v-for="savoir in savoirs" :key="savoir.id">
                  <div
                    v-ripple
                    class="select-none cursor-pointer p-3 hover:bg-gray-100"
                    @click="selectSavoir(savoir)"
                  >
                    <div>{{ savoir.nom }}</div>
                  </div>
                </div>
              </v-expansion-panel-content>
            </v-expansion-panel>
          </v-expansion-panels>
          <div class="flex flex-row p-3 justify-between">
            <v-btn text @click.native="closeRequest"> Annuler</v-btn>
          </div>
        </v-stepper-content>
        <v-stepper-content step="2">
          <div>
            <v-date-picker
              class="border-none"
              v-model="date"
              locale="fr-fr"
            ></v-date-picker>
          </div>
          <div class="flex flex-row p-3 justify-between">
            <v-btn text @click.native="stepperValue--"> Retour </v-btn>
            <v-btn text color="primary" @click.native="stepperValue++"
              >Continuer</v-btn
            >
          </div>
        </v-stepper-content>
        <v-stepper-content step="3">
          <div>
            <v-tabs v-model="tabs" height="0">
              <v-tab-item v-for="eleve in eleves" :key="eleve.id" class="">
                <div class="grid grid-cols-3">
                  <div></div>
                  <eleve-card-item
                    :eleve="eleve"
                    :showMoyenne="false"
                    :showUpdate="false"
                    :enableHover="false"
                  />
                </div>
                <v-form
                  lazy-validation
                  ref="form"
                  v-model="valid"
                  @submit.prevent="evaluateEleve(eleve)"
                >
                  <div
                    v-if="typeEvaluations === 'acquis'"
                    class="grid grid-cols-3"
                  >
                    <div></div>
                    <div>
                      <v-radio-group
                        row
                        v-model="currentEvaluation"
                        :disabled="currentAbsent"
                      >
                        <v-radio label="A." value="A."></v-radio>
                        <v-radio label="N.A." value="N.A."></v-radio>
                        <v-radio label="E.V.A." value="E.V.A."></v-radio>
                      </v-radio-group>
                      <v-textarea
                        auto-grow
                        rows="2"
                        label="Commentaire"
                        v-model="currentCommentaire"
                      />
                      <v-checkbox label="Absent" v-model="currentAbsent" />
                    </div>
                  </div>

                  <div class="grid grid-cols-2 gap-20" v-else>
                    <div>
                      <v-text-field
                        label="Nominateur"
                        type="number"
                        required
                        :rules="currentAbsent ? undefined : nombresRules"
                        v-model="currentNominateur"
                        :disabled="currentAbsent"
                      />
                      <v-text-field
                        label="Dénominateur"
                        type="number"
                        :rules="currentAbsent ? undefined : nombresRules"
                        required
                        v-model="currentDenominateur"
                        :disabled="currentAbsent"
                      />
                      <v-checkbox label="Absent" v-model="currentAbsent" />
                    </div>
                    <div>
                      <v-textarea
                        label="Commentaire"
                        v-model="currentCommentaire"
                      />
                    </div>
                  </div>
                </v-form>

                <div class="flex flex-row p-3 justify-between">
                  <v-btn text @click.native="stepperValue--"> Retour </v-btn>
                  <v-btn
                    text
                    color="primary"
                    @click.native="
                      stepperValue != 3 ? stepperValue++ : evaluateEleve(eleve)
                    "
                    >Continuer</v-btn
                  >
                </div>
              </v-tab-item>
            </v-tabs>
          </div>
        </v-stepper-content>
      </v-stepper-items>
    </v-stepper>
  </v-dialog>
</template>

<script>
import EleveCardItem from "../EleveCardItem.vue";
export default {
  components: { EleveCardItem },
  props: {
    value: Boolean,
    bulletin: {
      type: Object,
    },
  },

  computed: {
    matieres() {
      return this.$store.state.matieres;
    },
    eleves() {
      return this.$store.state.eleves;
    },
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
    evaluationProgress() {
      return (((this.tabs + 1) / this.eleves.length) * 100).toFixed();
    },
  },
  methods: {
    selectMatiere(matiere) {
      this.savoirs = this.$store.getters.savoirsByBulletinAndMatiere(
        this.bulletin,
        matiere
      );
    },
    selectSavoir(savoir) {
      this.savoirSelected = savoir;
      this.stepperValue++;
    },
    closeRequest() {
      this.$emit("closeRequest");
    },

    buildEvaluation() {
      if (!this.currentAbsent) {
        return this.typeEvaluations === "cotes"
          ? {
              nominateur: parseFloat(this.currentNominateur),
              denominateur: parseFloat(this.currentDenominateur),
              coteToText:
                this.currentNominateur.toString() +
                "/" +
                this.currentDenominateur.toString(),
              coteToPourcentage:
                (this.currentNominateur / this.currentDenominateur) * 100,
            }
          : this.currentEvaluation;
      } else return null;
    },
    evaluateEleve(eleve) {
      if (this.$refs.form[0].validate()) {
        this.results.push({
          eleve,
          bulletin: this.bulletin,
          evaluation: this.buildEvaluation(),
          absent: this.currentAbsent,
          savoir: this.savoirSelected,
          commentaire: this.currentCommentaire,
          date: new Date(this.date),
        });
        this.currentEvaluation = undefined;
        this.currentNominateur = undefined;
        this.currentAbsent = false;
        this.currentCommentaire = "";
        if (this.evaluationProgress == "100") this.onModalSubmit();
        this.tabs++;
      }
    },
    onModalSubmit() {
      this.$emit("bulletinSubmit", this.results);
    },
  },
  data() {
    return {
      valid: false,
      tabs: 0,
      savoirs: [],
      savoirSelected: {},
      matiereSelected: {},
      stepperValue: 1,
      date: new Date().toISOString().substr(0, 10),
      results: [],
      currentEvaluation: undefined,
      currentNominateur: undefined,
      currentDenominateur: undefined,
      currentCommentaire: "",
      currentAbsent: false,
      typeEvaluations: this.bulletin.classe.typeEvaluations,
      nombresRules: [(v) => !!v || "La valeure est requise"],
    };
  },
};
</script>

